'** 5/23/2003 9:47:23 AM
'** Pie in the Sky
'** Alyce Watson

    True = 1 : False = 0

dim d$(6,5) 'to hold data labels, values and colors
'1=label, 2=value, 3=backcolor, 4=outline color, 5=computer percentage
d$(1,3)="red"
d$(1,4)="darkred"
d$(2,3)="green"
d$(2,4)="darkgreen"
d$(3,3)="blue"
d$(3,4)="darkblue"
d$(4,3)="pink"
d$(4,4)="darkpink"
d$(5,3)="cyan"
d$(5,4)="darkcyan"
d$(6,3)="yellow"
d$(6,4)="brown"

hCloud=LoadImageFile(0,"clouds.jpg")
loadbmp "clouds",hCloud

[WindowSetup]
    NOMAINWIN
    WindowWidth = 640 : WindowHeight = 480
    UpperLeftX = INT((DisplayWidth-WindowWidth)/2)
    UpperLeftY = INT((DisplayHeight-WindowHeight)/2)

[ControlSetup]

Menu        #main, "&File" , "&Create Chart",[create],_
            "&Save Chart",[save],"&Print Chart",[printit],_
            "&About",[about],"E&xit", [quit]
graphicbox  #main.g, 220, 15, 400, 400
statictext  #main.s1, "Data Label:", 10, 30, 90, 20
statictext  #main.s2, "Data:", 150, 30, 40, 16
button      #main.create, "Create Chart",[create],UL, 100, 215, 115, 25
button      #main.save, "Save Chart",[save],UL, 100, 245, 115, 25
button      #main.printit, "Print Chart",[printit],UL, 100, 275, 115, 25
button      #main.reset, "Reset",[reset],UL, 100, 305, 115, 25
button      #main.quit, "Exit",[quit],UL, 100, 335, 115, 25
button      #main.about, "About",[about],UL, 100, 390, 115, 25
TextboxColor$    = "Red"
textbox     #main.t1, 5, 55, 140, 25
textbox     #main.t2, 145, 55, 70, 25
TextboxColor$    = "Green"
textbox     #main.t3, 5, 80, 140, 25
textbox     #main.t4, 145, 80, 70, 25
TextboxColor$    = "Blue"
textbox     #main.t5, 5, 105, 140, 25
textbox     #main.t6, 145, 105, 70, 25
TextboxColor$    = "Pink"
textbox     #main.t7, 5, 130, 140, 25
textbox     #main.t8, 145, 130, 70, 25
TextboxColor$    = "Cyan"
textbox     #main.t9, 5, 155, 140, 25
textbox     #main.t10, 145, 155, 70, 25
TextboxColor$    = "Yellow"
textbox     #main.t11, 5, 180, 140, 25
textbox     #main.t12, 145, 180, 70, 25

Open "Pie in the Sky" for Window as #main
    #main "trapclose [quit]"
    #main.g "down; drawbmp clouds 0 0; flush"
    #main.g "font courier_new 10"
    #main.t1 "!setfocus"
    #main "font courier_new 10"

[loop]
    Wait

[quit]
    unloadbmp "clouds"
    close #main 
    if tname$<>"" then kill tname$
    END


[create]
    #main.t1 "!contents? a$"
    d$(1,1)=a$
    #main.t2 "!contents? a$"
    d$(1,2)=a$
    #main.t3 "!contents? a$"
    d$(2,1)=a$
    #main.t4 "!contents? a$"
    d$(2,2)=a$
    #main.t5 "!contents? a$"
    d$(3,1)=a$
    #main.t6 "!contents? a$"
    d$(3,2)=a$
    #main.t7 "!contents? a$"
    d$(4,1)=a$
    #main.t8 "!contents? a$"
    d$(4,2)=a$
    #main.t9 "!contents? a$"
    d$(5,1)=a$
    #main.t10 "!contents? a$"
    d$(5,2)=a$
    #main.t11 "!contents? a$"
    d$(6,1)=a$
    #main.t12 "!contents? a$"
    d$(6,2)=a$
    
    'compute total
    wholepie=0
    for i = 1 to 6
        wholepie=wholepie+val(d$(i,2))
    next
    
    if wholepie=0 then 
        notice "No Data"
        wait
    end if
    
    'compute percentages, pad text
    for i = 1 to 6
        d$(i,5)=str$(val(d$(i,2))/wholepie*100) 'percent
        d$(i,5)=using("###.##",d$(i,5))         'format number
        d$(i,2)=str$(val(d$(i,2))/wholepie*360) 'degrees
        d$(i,1)=PadString$(d$(i,1))
    next
    
    'now draw da chart:
    ychart=160
    ylegend=300
    #main.g "down; place 200 ";ychart
    
    for k = 1 to 30 'print 30 pies in increments to make it look 3D
        ychart=ychart-1
        startpos=0
   
    for i = 1 to 6
        #main.g "place 200 ";ychart
        #main.g "color ";d$(i,4)
        #main.g "backcolor ";d$(i,3)
        if val(d$(i,2))>0 then 
            #main.g "piefilled 360 180 ";startpos;" ";d$(i,2)
            startpos=startpos+val(d$(i,2))
            if k=1 then  'first time through print legend
                #main.g "place 46 ";ylegend
                #main.g "color black"
                #main.g "\";d$(i,1);" ";d$(i,5)+"%"

                ylegend=ylegend+16
            end if
        end if
    next
    next
    #main.g "flush"
    wait

[save]
    filedialog "Save As","piechart.bmp",savename$
    if savename$="" then wait
    #main.g "getbmp chart 0 0 398 398"
    bmpsave "chart",savename$
    wait

[printit]
    #main.g "getbmp chart 0 0 398 398"
    tname$=DefaultDir$+"\tempchart.bmp"
    bmpsave "chart",tname$
    run "mspaint.exe " + chr$(34)+  tname$ + chr$(34) + " /p"
    wait
    
[reset]
    #main.t1 ""
    #main.t2 ""
    #main.t3 ""
    #main.t4 ""
    #main.t5 ""
    #main.t6 ""
    #main.t7 ""
    #main.t8 ""
    #main.t9 ""
    #main.t10 ""
    #main.t11 ""
    #main.t12 ""
    print #main.g, "down; drawbmp clouds 0 0; flush"
    #main.t1 "!setfocus"
    wait

[about]
    notice "Alyce Watson, 2003"
    wait

Function PadString$(st$)
    if len(st$)<30 then
        st$=st$+space$(30-len(st$))
    end if
    PadString$=left$(st$,30)
    end Function
    
Function LoadImageFile(hWnd, file$)
    open "jpeg.dll" for dll as #j
    calldll #j, "LoadImageFile",_
    hWnd as ulong,_
    file$ as ptr,_
    LoadImageFile as ulong
    close #j
    End Function


