'** 6/11/2003 
'** Pie in the Sky
'** Alyce Watson

    True = 1 : False = 0

dim d$(8,5) 'to hold data labels, values and colors
'1=label, 2=value, 3=backcolor, 4=outline color, 5=computer percentage
d$(1,3)="red"
d$(1,4)="darkred"
d$(2,3)="green"
d$(2,4)="darkgreen"
d$(3,3)="blue"
d$(3,4)="darkblue"
d$(4,3)="pink"
d$(4,4)="darkpink"
d$(5,3)="cyan"
d$(5,4)="darkcyan"
d$(6,3)="yellow"
d$(6,4)="brown"
d$(7,3)="white"
d$(7,4)="lightgray"
d$(8,3)="darkgray"
d$(8,4)="black"

higuy=0

hCloud=LoadImageFile(0,"clouds.jpg")
loadbmp "clouds",hCloud

[WindowSetup]
    NOMAINWIN
    WindowWidth = 640 : WindowHeight = 480
    UpperLeftX = INT((DisplayWidth-WindowWidth)/2)
    UpperLeftY = INT((DisplayHeight-WindowHeight)/2)

[ControlSetup]

Menu        #main, "&File" , "&Create Chart",[create],_
            "&Save Chart",[save],"&Print Chart",[printit],_
            "E&xit", [quit]
Menu        #main, "&Help", "&Topics",[help],_
            "&About",[about]
graphicbox  #main.g, 220, 15, 400, 400
statictext  #main.s0, "V",8,30,20,20
statictext  #main.s1, "Data Label:", 40, 30, 110, 20
statictext  #main.s2, "Data:", 150, 30, 40, 16
button      #main.create, "Create Chart",[create],UL, 10, 330, 115, 25
button      #main.reset, "Reset",[reset],UL, 10, 360, 115, 25
button      #main.quit, "Exit",[quit],UL, 10, 390, 115, 25
button      #main.right, ">>",[right],UL,165,360,30,25
button      #main.left, "<<",[left],UL,135,360,30,25
statictext  #main.s4, "Rotate",135,330,60,20
TextboxColor$    = "Red"
radiobutton #main.r1,"",[red],[null],5,55,25,25
textbox     #main.t1, 30, 55, 115, 25
textbox     #main.t2, 145, 55, 70, 25
TextboxColor$    = "Green"
radiobutton #main.r2,"",[green],[null],5,80,25,25
textbox     #main.t3, 30, 80, 115, 25
textbox     #main.t4, 145, 80, 70, 25
TextboxColor$    = "Blue"
radiobutton #main.r3,"",[blue],[null],5,105,25,25
textbox     #main.t5, 30, 105, 115, 25
textbox     #main.t6, 145, 105, 70, 25
TextboxColor$    = "Pink"
radiobutton #main.r4,"",[pink],[null],5,130,25,25
textbox     #main.t7, 30, 130, 115, 25
textbox     #main.t8, 145, 130, 70, 25
TextboxColor$    = "Cyan"
radiobutton #main.r5,"",[cyan],[null],5,155,25,25
textbox     #main.t9, 30, 155, 115, 25
textbox     #main.t10, 145, 155, 70, 25
TextboxColor$    = "Yellow"
radiobutton #main.r6,"",[yellow],[null],5,180,25,25
textbox     #main.t11, 30, 180, 115, 25
textbox     #main.t12, 145, 180, 70, 25
TextboxColor$    = "White"
radiobutton #main.r7,"",[white],[null],5,205,25,25
textbox     #main.t13, 30, 205, 115, 25
textbox     #main.t14, 145, 205, 70, 25
TextboxColor$    = "Darkgray"
radiobutton #main.r8,"",[gray],[null],5,225,25,25
textbox     #main.t15, 30, 225, 115, 25
textbox     #main.t16, 145, 225, 70, 25
radiobutton #main.r0," No Highlighted Section",[none],[null],5,250,210,25

Open "Pie in the Sky" for Window as #main
    #main "trapclose [quit]"
    #main "font courier_new 10"
    #main.g "down; drawbmp clouds 0 0; flush"
    #main.g "font courier_new 10"
    #main.s0 "!font ms_sans_serif 10 bold"
    #main.t1 "!setfocus"
    #main.r0 "set"

[loop]
    Wait

[quit]
    unloadbmp "clouds"
    close #main 
    if tname$<>"" then kill tname$
    END


[create]
    #main.t1 "!contents? a$"
    d$(1,1)=a$
    #main.t2 "!contents? a$"
    d$(1,2)=a$
    #main.t3 "!contents? a$"
    d$(2,1)=a$
    #main.t4 "!contents? a$"
    d$(2,2)=a$
    #main.t5 "!contents? a$"
    d$(3,1)=a$
    #main.t6 "!contents? a$"
    d$(3,2)=a$
    #main.t7 "!contents? a$"
    d$(4,1)=a$
    #main.t8 "!contents? a$"
    d$(4,2)=a$
    #main.t9 "!contents? a$"
    d$(5,1)=a$
    #main.t10 "!contents? a$"
    d$(5,2)=a$
    #main.t11 "!contents? a$"
    d$(6,1)=a$
    #main.t12 "!contents? a$"
    d$(6,2)=a$
    #main.t13 "!contents? a$"
    d$(7,1)=a$
    #main.t14 "!contents? a$"
    d$(7,2)=a$
    #main.t15 "!contents? a$"
    d$(8,1)=a$
    #main.t16 "!contents? a$"
    d$(8,2)=a$
    
    'compute total
    wholepie=0
    for i = 1 to 8
        wholepie=wholepie+val(d$(i,2))
    next
    
    if wholepie=0 then 
        notice "No Data"
        wait
    end if
    
    'compute percentages, pad text
    for i = 1 to 8
        d$(i,5)=str$(val(d$(i,2))/wholepie*100) 'percent
        d$(i,5)=using("###.##",d$(i,5))         'format number
        d$(i,2)=str$(val(d$(i,2))/wholepie*360) 'degrees
        d$(i,1)=PadString$(d$(i,1))
    next
        
    'now draw da chart:
    ychart=140
    ylegend=266
    #main.g "segment segID"
    #main.g "down; drawbmp clouds 0 0; place 200 ";ychart
    startpos=startpos + rotNum
   
    for k = 1 to 30 'print 30 pies in increments to make it look 3D
        ychart=ychart-1
   
    for i = 1 to 8
        #main.g "place 200 ";ychart
        #main.g "color ";d$(i,4)
        #main.g "backcolor ";d$(i,3)
        ang=val(d$(i,2))
        if ang>0 then 
            if i = higuy then                
                outx=35*cos((startpos+0.5*ang)*3.14159265/180)
                outy=35*sin((startpos+0.5*ang)*3.14159265/180)*120/300
                #main.g "place ";200+outx;" ";ychart+outy
                #main.g "piefilled 320 140 ";startpos;" ";ang
            else
                #main.g "piefilled 320 140 ";startpos;" ";ang
            end if
            startpos=startpos+ang
            if k=1 then  'first time through print legend
                #main.g "place 46 ";ylegend
                #main.g "color black"
                #main.g "\";d$(i,1);" ";d$(i,5)+"%"

                ylegend=ylegend+16
            end if
        end if
    next
    next
    #main.g "delsegment ";segID-1
    #main.g "flush"
    wait

[save]
    filedialog "Save As","piechart.bmp",savename$
    if savename$="" then wait
    #main.g "getbmp chart 0 0 398 398"
    bmpsave "chart",savename$
    wait

[printit]
    #main.g "getbmp chart 0 0 398 398"
    tname$=DefaultDir$+"\tempchart.bmp"
    bmpsave "chart",tname$
    run "mspaint.exe " + chr$(34)+  tname$ + chr$(34) + " /p"
    wait
    
[reset]
    #main.t1 "" : #main.t2 "" : #main.t3 ""
    #main.t4 "" : #main.t5 "" : #main.t6 ""
    #main.t7 "" : #main.t8 "" : #main.t9 ""
    #main.t10 "" :#main.t11 "": #main.t12 ""
    #main.t11 "" :#main.t12 "": #main.t13 ""
    #main.t14 "" 
    #main.r0 "set" : #main.t1 "!setfocus"
    print #main.g, "cls; down; drawbmp clouds 0 0; flush"
    higuy=0 :startpos=0
    wait

[red] higuy=1 : goto [create]
[green] higuy=2 : goto [create]
[blue] higuy=3 : goto [create]
[pink] higuy=4 : goto [create]
[cyan] higuy=5 : goto [create]
[yellow] higuy=6 : goto [create]
[white] higuy=7 : goto [create]
[gray] higuy=8 : goto [create]
[none] higuy=0 : goto [create]
[right] rotNum=-15 : goto [create]
[left] rotNum=15 : goto [create]

[help]
    lpszOp$ =  "open"
    lpszFile$ = DefaultDir$+"\piechart.mht"
    lpszDir$ = DefaultDir$ : lpszParams$=""

    CallDLL #shell32, "ShellExecuteA",_
    0 As long,lpszOp$ As ptr, lpszFile$ As ptr,_  
    lpszParams$ As ptr,lpszDir$ As ptr,_   
    _SW_SHOWNA As long, result As long      
    wait
    
[about]
    notice chr$(169) + " 2003, Alyce Watson. All Rights Reserved."
    wait

Function PadString$(st$)
    if len(st$)<30 then
        st$=st$+space$(30-len(st$))
    end if
    PadString$=left$(st$,30)
    end Function
    
Function LoadImageFile(hWnd, file$)
    open "jpeg.dll" for dll as #j
    calldll #j, "LoadImageFile",_
    hWnd as ulong,file$ as ptr,_
    LoadImageFile as ulong
    close #j
    End Function






